
/* ###--------------------------------------------------------------### */
/*									*/
/* file		: vh_utdef.h						*/
/* date		: Nov 14 1992						*/
/* version	: v1.7							*/
/* author	: Pirouz BAZARGAN SABET					*/
/* content	: defines used in `vh_util.c`				*/
/*									*/
/* ###--------------------------------------------------------------### */


#define VHU_ROTDFN    1			/* root model			 */	
#define VHU_CHDDFN    2			/* child model			 */


#define VHU_ICNDFN     1                /* input 	port             */
#define VHU_OCNDFN     2                /* output 	port             */
#define VHU_BCNDFN     3                /* inout 	port             */

#define VHU_BITDFN     8                /* bit 		type             */
#define VHU_MUXDFN    16                /* mux_bit 	type             */
#define VHU_WORDFN    24                /* wor_bit 	type             */
#define VHU_RBIDFN    32                /* reg_bit 	type             */
#define VHU_BTVDFN    40                /* bit_vector 	type             */
#define VHU_MXVDFN    48                /* mux_vector 	type             */
#define VHU_WRVDFN    56                /* wor_vector 	type             */
#define VHU_RGVDFN    64                /* reg_vector 	type             */
#define VHU_CVTDFN    72                /* convertion 	type             */
#define VHU_BOLDFN    80                /* boolean	type           	 */

#define VHU_NORDFN   128                /* non guarded 	signal           */
#define VHU_BUSDFN   256                /* guarded 	signal (bus)     */
#define VHU_REGDFN   384                /* guarded 	signal (register)*/

#define VHU_MODMSK     7                /* signal mode  mask (3 bits)    */
#define VHU_TYPMSK   120                /* signal type  mask (4 bits)    */
#define VHU_GRDMSK   896                /* signal guard mask (3 bits)    */

#define VHU_NAMDFN 0
#define VHU_NEWDFN 1

#define VHU_MODDFN     0		/* mod_val field of dct_recrd	 */
#define VHU_SIGDFN     1		/* sig_val field of dct_recrd	 */
#define VHU_CCNDFN     2		/* ccn_val field of dct_recrd	 */
#define VHU_RNGDFN     3		/* rng_val field of dct_recrd	 */
#define VHU_LBLDFN     4		/* lbl_val field of dct_recrd	 */
#define VHU_WMXDFN     5                /* wmx_val field of dct_recrd    */
#define VHU_WMNDFN     6                /* wmn_val field of dct_recrd    */
#define VHU_PNTDFN     7                /* pnt_val field of dct_recrd    */

#define VHU_ALODFN     60		/* minimal size of allocation	 */
					/* for dct_entry and dct_recrd	 */
#define VHU_HSZDFN    307		/* number of entry points in the */
					/* dictionnary			 */
#define VHU_MXRDFN 30
